<template>
    <q-layout view="hHh LpR fFf" style="height: 100vh">

        <q-header elevated class="bg-primary text-white">
            <q-toolbar>
                <q-btn dense flat round icon="menu" @click="left = !left" v-if="!BarOnly"/>

                <q-toolbar-title>
                    <q-avatar>
                        <img :src="$images.logo" alt="logo">
                    </q-avatar>
                    {{ Title }}
                </q-toolbar-title>

                <q-btn dense flat round :icon="Store.StoreValue.rightIcon" @click="right = !right"
                       v-if="!BarOnly || Store.StoreValue.rightIcon === ''"/>
            </q-toolbar>
            <q-tabs v-show="ShowTabs" align="left" inline-label outside-arrows
                    mobile-arrows>
                <q-route-tab v-for="t in Tabs" :key="t.label" :to="t.link" :icon="t.icon" :label="t.label"
                />
            </q-tabs>
            <q-linear-progress
                v-if="Store.StoreValue.loading"
                indeterminate color="primary" :track-color="dark ? 'dark' : 'white'" class="q-mt-sm"/>
        </q-header>

        <q-drawer v-model="left" side="left" bordered class="column justify-between" v-if="!BarOnly ">
            <Profile class="absolute-top"/>
            <q-scroll-area style="height: calc(100% - 223px); margin-top: 135px; border-right: 1px solid #ddd">
                <q-list v-for="(link , ii) in Links" :key="ii">

                    <NavLink v-for="(l, index) in link"
                             :key="index" :title="l.name" :icon="l.icon" :link="l.link" :caption="l.caption"/>
                    <q-separator/>
                </q-list>
                <q-space/>
                <div class="fixed-bottom">

                    <q-list dense>
                        <q-item tag="label" v-ripple>
                            <q-item-section>
                                <q-item-label> Dark Mode</q-item-label>
                            </q-item-section>
                            <q-item-section avatar>
                                <q-toggle v-model="dark"/>
                            </q-item-section>
                        </q-item>
                        <NavLink title="Logout" caption="Exit" @click.native="$auth.Logout"/>
                    </q-list>

                </div>
            </q-scroll-area>


        </q-drawer>

        <q-drawer v-model="right" side="right" bordered v-if="!BarOnly && Store.StoreValue.rightIcon !== ''">
            <FloorPlanFilter v-if="Store.StoreValue.filter === 'floorplan'"/>
            <ChartFilter v-if="Store.StoreValue.filter === 'graph'"/>
        </q-drawer>

        <q-page-container v-if="errors.length === 0 && unknownError === '' && authError === ''">
            <router-view v-transition="transition" :id="topId"/>
        </q-page-container>

        <q-page-container v-else-if="errors.length > 0">
            <q-page :id="topId">
                <ErrorComponent :max-height="1" :animation="$animations.errors.icecream"
                                text="Error - Ice-cream fell"
                                :error-detail="errors"
                />
            </q-page>
        </q-page-container>


        <q-page-container v-else-if="unknownError !== ''">
            <q-page :id="topId">
                <ErrorComponent :max-height="1" v-for="(e,i) in Errors" v-if="i===0" key="err"
                                :text="'Error - ' + e.text"
                                :error-detail="unknownError"
                />
            </q-page>
        </q-page-container>


        <q-page-container v-else>
            <q-page :id="topId">

                <ErrorComponent :max-height="1" :animation="$animations.errors.noTissue"
                                text="Error - No Tissue"
                                :error-detail="authError"/>
            </q-page>
        </q-page-container>


    </q-layout>
</template>
<script lang="ts">

import {Component, Vue} from "vue-property-decorator";
import NavLink from "components/Core/NavLink.vue";
import {Route} from 'vue-router'
import {Link} from "src/classLibrary/Core/StrongTyping/Link";
import {Tab} from "src/classLibrary/Core/StrongTyping/Tabs";
import Profile from "components/Core/Profile.vue";
import {ApiError} from "src/classLibrary/Core/Api";
import ErrorComponent from "components/Core/ErrorComponent.vue";
import {StandardDotNetError} from "src/classLibrary/Core/Standard";
import FloorPlanFilter from "components/Filters/FloorPlanFilter.vue";
import {developer, links} from "layouts/links";
import AsyncComputed from 'vue-async-computed-decorator'
import ChartFilter from "components/Filters/ChartFilter.vue";


const ENTER_DEF = 'fadeInRight';
const LEAVE_DEF = 'fadeInLeft';


@Component({
    components: {ChartFilter, FloorPlanFilter, ErrorComponent, Profile, NavLink}
})
export default class MainLayout extends Vue {

    authError: string = '';
    errors: string[] = [];
    unknownError: string = '';

    topId = 'main-page';

    get BarOnly() {
        return this.PersistentStore.StoreValue.project === '';
    }

    @AsyncComputed()
    async Links(): Promise<Link[][]> {
        const admin = await this.$auth.IsAdmin;
        if (admin) {
            return [...links, developer];
        }
        return links;
    }


    async created() {
        const p = this;
        const r = await this.$coreApi.Get<string[]>("timezones")
        r.match({
            ok: (o) => {
                p.Store.StoreValue.timeZone = o;
            },
            err: (e) => ApiError.match(e, {
                Null: (e) => {
                    const err = (e.error?.IsEmpty() ?? true) ? 'Not found' : e.error!;
                    console.error(e);
                    p.errors = [err];
                },
                Object: (e) => {
                    const dne = e as any as StandardDotNetError;
                    new Map<string, string[]>(Object.entries(dne.errors))
                        .Each((_, v) => p.errors.push(...v));
                },
                Auth: (e) => {
                    const err = (e.error?.IsEmpty() ?? true) ? 'No permission' : e.error;
                    console.error(err);
                    p.authError = err
                },
                String: (e) => {
                    p.errors = [e.error];
                },
                Unknown: (e) => {
                    console.error(e);
                    if (typeof e.error === "string") {
                        p.unknownError = (e.error?.IsEmpty() ?? true) ? "Unknown Error" : ""
                    } else {
                        p.unknownError = JSON.parse(e.error ?? {})
                    }
                }
            })
        })

        this.$router.beforeEach((to: Route, from: Route, next) => {
            this.transition.enter = ENTER_DEF;
            this.transition.leave = LEAVE_DEF;
            if (to?.meta?.transition?.enter) {
                this.transition.enter = to.meta.transition.enter
            }
            if (from?.meta?.transition?.leave) {
                this.transition.leave = to.meta.transition.leave
            }

            next();
        });
    }

    get Errors(): { error: object, text: string }[] {
        return [
            {
                error: this.$animations.errors.alienInvasion,
                text: 'Alien Invasion'
            },
            {
                error: this.$animations.errors.coffeeSplit,
                text: 'Coffee Spilt'
            },
            {
                error: this.$animations.errors.chemicalExplosion,
                text: 'Chemicals Exploded'
            }
        ]
    }


    left = false;
    right = false;

    transition: { enter: string, leave: string } = {
        enter: ENTER_DEF,
        leave: LEAVE_DEF,
    }

    get Title() {

        const suffix = this.PersistentStore.StoreValue.projectName;
        const prefix = this.Store.StoreValue.title;
        if (prefix.IsEmpty()) {
            return suffix;
        }
        return prefix;
    }

    get Tabs(): Tab[] {
        return this.Store.StoreValue.tabs;
    }

    get ShowTabs() {
        return this.Store.StoreValue.tabs.length > 0;
    }


}
</script>
